 /*
     StataWorkshopExerciseAnswers.do
     Christine Leibbrand
     February 2020
     Code for Exercises in Introduction to Stata Workshop 
*/

***********************************************
*** Exercise 1: renaming and labeling variables
***********************************************

rename CV_HGC_BIO_DAD_1997 dadedu_1997
rename CV_HGC_BIO_MOM_1997 momedu_1997
rename CVC_HIGHEST_DEGREE_EVER_XRND ownedu_1997
rename YSAQ_INTRO_3_1997 favicecr_1997
rename YHEA_100_1997 genhealth_1997

label variable dadedu_1997 "Bio dad’s highest grade completed"
label variable momedu_1997 "Bio mom’s highest grade completed"
label variable ownedu_1997 "Own highest grade completed"
label variable favicecr_1997 "Favorite ice cream flavor"
label variable genhealth_1997 "Reported level of general health"

tab dadedu_1997
tab momedu_1997
tab ownedu_1997
tab favicecr_1997
tab genhealth_1997

/*
. tab dadedu_1997

       Bio dad’s highest |
         grade completed |      Freq.     Percent        Cum.
-------------------------+-----------------------------------
                      -4 |        668        7.44        7.44
                      -3 |      1,188       13.22       20.66
               1ST GRADE |          1        0.01       20.67
               2ND GRADE |         19        0.21       20.88
               3RD GRADE |         68        0.76       21.64
               4TH GRADE |         59        0.66       22.30
               5TH GRADE |         68        0.76       23.05
               6TH GRADE |        188        2.09       25.14
               7TH GRADE |         92        1.02       26.17
               8TH GRADE |        169        1.88       28.05
               9TH GRADE |        240        2.67       30.72
              10TH GRADE |        329        3.66       34.38
              11TH GRADE |        396        4.41       38.79
              12TH GRADE |      2,728       30.37       69.16
        1ST YEAR COLLEGE |        381        4.24       73.40
        2ND YEAR COLLEGE |        736        8.19       81.59
        3RD YEAR COLLEGE |        176        1.96       83.55
        4TH YEAR COLLEGE |        840        9.35       92.90
        5TH YEAR COLLEGE |        113        1.26       94.16
        6TH YEAR COLLEGE |        270        3.01       97.16
        7TH YEAR COLLEGE |         85        0.95       98.11
8TH YEAR COLLEGE OR MORE |        162        1.80       99.91
                UNGRADED |          8        0.09      100.00
-------------------------+-----------------------------------
                   Total |      8,984      100.00

. tab momedu_1997

       Bio mom’s highest |
         grade completed |      Freq.     Percent        Cum.
-------------------------+-----------------------------------
                      -4 |        165        1.84        1.84
                      -3 |        523        5.82        7.66
               1ST GRADE |          6        0.07        7.72
               2ND GRADE |         29        0.32        8.05
               3RD GRADE |         54        0.60        8.65
               4TH GRADE |         52        0.58        9.23
               5TH GRADE |         57        0.63        9.86
               6TH GRADE |        222        2.47       12.33
               7TH GRADE |         69        0.77       13.10
               8TH GRADE |        205        2.28       15.38
               9TH GRADE |        273        3.04       18.42
              10TH GRADE |        428        4.76       23.19
              11TH GRADE |        562        6.26       29.44
              12TH GRADE |      3,038       33.82       63.26
        1ST YEAR COLLEGE |        642        7.15       70.40
        2ND YEAR COLLEGE |      1,002       11.15       81.56
        3RD YEAR COLLEGE |        248        2.76       84.32
        4TH YEAR COLLEGE |        908       10.11       94.42
        5TH YEAR COLLEGE |        157        1.75       96.17
        6TH YEAR COLLEGE |        227        2.53       98.70
        7TH YEAR COLLEGE |         34        0.38       99.08
8TH YEAR COLLEGE OR MORE |         77        0.86       99.93
                UNGRADED |          6        0.07      100.00
-------------------------+-----------------------------------
                   Total |      8,984      100.00

. tab ownedu_1997

Own highest |
      grade |
  completed |      Freq.     Percent        Cum.
------------+-----------------------------------
         -3 |         32        0.36        0.36
          0 |      1,000       11.13       11.49
          1 |      1,127       12.54       24.03
          2 |      3,767       41.93       65.96
          3 |        703        7.83       73.79
          4 |      1,674       18.63       92.42
          5 |        532        5.92       98.34
          6 |         43        0.48       98.82
          7 |        106        1.18      100.00
------------+-----------------------------------
      Total |      8,984      100.00

. tab favicecr_1997

   Favorite |
  ice cream |
     flavor |      Freq.     Percent        Cum.
------------+-----------------------------------
         -3 |          2        0.02        0.02
         -2 |          5        0.06        0.08
         -1 |          2        0.02        0.10
          1 |      2,951       32.85       32.95
          2 |      2,523       28.08       61.03
          3 |      1,983       22.07       83.10
          4 |        915       10.18       93.29
          5 |        603        6.71      100.00
------------+-----------------------------------
      Total |      8,984      100.00

. tab genhealth_1997

   Reported |
   level of |
    general |
     health |      Freq.     Percent        Cum.
------------+-----------------------------------
         -3 |          2        0.02        0.02
         -2 |          3        0.03        0.06
          1 |      3,477       38.70       38.76
          2 |      3,025       33.67       72.43
          3 |      2,020       22.48       94.91
          4 |        430        4.79       99.70
          5 |         27        0.30      100.00
------------+-----------------------------------
      Total |      8,984      100.00


*/
***********************************************************
/*Exercise 2: Create and apply a value label to ownedu_1997 
and then tabulate to check your work
*/
***********************************************************

*** Define label
label define ownedlabel -3 "-3 Missing" 0 "0 None"  1 "1 GED"  2 "2 High school diploma" ///
 3 "3 Associate/Junior college"  4 "4 College Degree"  5 "5 Master's degree"  6 "PhD"  7 "Professional degree" 

*** Apply label
label values ownedu_1997 ownedlabel

*** Check work
tab ownedu_1997

/*
. tab ownedu_1997

         Own highest grade |
                 completed |      Freq.     Percent        Cum.
---------------------------+-----------------------------------
                -3 Missing |         32        0.36        0.36
                    0 None |      1,000       11.13       11.49
                     1 GED |      1,127       12.54       24.03
     2 High school diploma |      3,767       41.93       65.96
3 Associate/Junior college |        703        7.83       73.79
          4 College Degree |      1,674       18.63       92.42
         5 Master's degree |        532        5.92       98.34
                       PhD |         43        0.48       98.82
       Professional degree |        106        1.18      100.00
---------------------------+-----------------------------------
                     Total |      8,984      100.00

. 
*/

***********************************************************
/*Exercise 3: Create and apply a value label to safesch_1997  
and then tabulate to check your work
*/
***********************************************************

*** Define label
label define safeschlabel -4 "-4 Valid Skip" -2 "-2 Don't Know" -1 "-1 Refusal" ///
1 "1 Strongly Agree"  2 "2 Agree"  3 "3 Disagree"  4 "4 Strongly Disagree"

*** Apply label
label values safesch_1997 safeschlabel

*** Check work
tab safesch_1997

/*
. tab safesch_1997

   YSCH_37000_1997, |
  respondent report |
  of agreement they |
feel safe at school |      Freq.     Percent        Cum.
--------------------+-----------------------------------
      -4 Valid Skip |         14        0.16        0.16
      -2 Don't Know |          9        0.10        0.26
         -1 Refusal |          2        0.02        0.28
   1 Strongly Agree |      2,798       31.14       31.42
            2 Agree |      4,870       54.21       85.63
         3 Disagree |      1,018       11.33       96.96
4 Strongly Disagree |        273        3.04      100.00
--------------------+-----------------------------------
              Total |      8,984      100.00

*/

**************************************************************************

************************************************************************
*****Exercise 4: Set missing values for favicecr_1997 and dadedu_1997***
************************************************************************

*** Recode missing values for faveicr_1997
*Set missing values equal so they identify type of missingness
recode favicecr_1997 (-3 = .i) (-2 =.d) (-1 = .r)

*Set missing values so they are not unique
*recode favicecr_1997 (-3 -2 -1 = .)

*** Check work
tab favicecr_1997, missing

/*
. tab favicecr_1997, missing

   Favorite |
  ice cream |
     flavor |      Freq.     Percent        Cum.
------------+-----------------------------------
          1 |      2,951       32.85       32.85
          2 |      2,523       28.08       60.93
          3 |      1,983       22.07       83.00
          4 |        915       10.18       93.19
          5 |        603        6.71       99.90
         .d |          5        0.06       99.96
         .i |          2        0.02       99.98
         .r |          2        0.02      100.00
------------+-----------------------------------
      Total |      8,984      100.00
*/

*** Recode missing values for dadedu_1997
*Set missing values equal so they identify type of missingness
recode dadedu_1997 (-4 = .v) (-3 =.i) (95 = .u)

*Set missing values so they are not unique
*recode dadedu_1997 (-4 -3 95 = .)

*** Check work
tab dadedu_1997, missing

/*
. tab dadedu_1997, missing

       Bio dad’s highest |
         grade completed |      Freq.     Percent        Cum.
-------------------------+-----------------------------------
               1ST GRADE |          1        0.01        0.01
               2ND GRADE |         19        0.21        0.22
               3RD GRADE |         68        0.76        0.98
               4TH GRADE |         59        0.66        1.64
               5TH GRADE |         68        0.76        2.39
               6TH GRADE |        188        2.09        4.49
               7TH GRADE |         92        1.02        5.51
               8TH GRADE |        169        1.88        7.39
               9TH GRADE |        240        2.67       10.06
              10TH GRADE |        329        3.66       13.72
              11TH GRADE |        396        4.41       18.13
              12TH GRADE |      2,728       30.37       48.50
        1ST YEAR COLLEGE |        381        4.24       52.74
        2ND YEAR COLLEGE |        736        8.19       60.93
        3RD YEAR COLLEGE |        176        1.96       62.89
        4TH YEAR COLLEGE |        840        9.35       72.24
        5TH YEAR COLLEGE |        113        1.26       73.50
        6TH YEAR COLLEGE |        270        3.01       76.50
        7TH YEAR COLLEGE |         85        0.95       77.45
8TH YEAR COLLEGE OR MORE |        162        1.80       79.25
                      .i |      1,188       13.22       92.48
                      .u |          8        0.09       92.56
                      .v |        668        7.44      100.00
-------------------------+-----------------------------------
                   Total |      8,984      100.00

*/
**************************************************************************


**********************************************************************
/*
Exercise 5: Create a dichotomous variable indicating if the 
respondent reports having excellent/very good/good health (=1) 
or whether the respondent reports having fair/poor health (=0)
in response to the genhealth_1997 measure
*/
******************************************************************

***Check values for the genhealth_1997 measure
tab genhealth_1997,m

*** Generating our health dichotomous variable and setting it = to . so values are empty
gen health_cat_1997 = .

*** Add in our values so that health_cat_1997 takes a value of:
*** 1 if genhealth_1997 takes values 1, 2, or 3
*** 0 if genhealth_1997 takes values 4 or 5
*** Leave it missing if genhealth_1997 = .

replace health_cat_1997 = 0 if(genhealth_1997==3|genhealth_1997==4)
replace health_cat_1997 = 1 if(genhealth_1997>=1 & genhealth_1997<=2)

*Check your work
tab genhealth_1997 health_cat_1997

/*
. tab genhealth_1997 health_cat_1997

 Reported level |
     of general |    health_cat_1997
         health |         0          1 |     Total
----------------+----------------------+----------
    1 Excellent |         0      3,477 |     3,477 
    2 Very Good |         0      3,025 |     3,025 
         3 Good |     2,020          0 |     2,020 
         4 Fair |       430          0 |       430 
----------------+----------------------+----------
          Total |     2,450      6,502 |     8,952 

*/

*** Messed up a variable when you created it? Use "drop" to get rid of the varaible and start again

drop health_cat_1997
